unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Menus, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnAddMenuItem: TButton;
    MainMenu: TMainMenu;
    miMenu: TMenuItem;
    procedure btnAddMenuItemClick(Sender: TObject);
  private
    procedure MenuClickHandler(Sender: TObject);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnAddMenuItemClick(Sender: TObject);
var
  s:string;
  aTargetMenu, aMenuItem: TMenuItem;
begin
  aTargetMenu:= MainMenu.Items.Find('&Menu');
  s:='MenuItem ' +IntToStr(aTargetMenu.Count +1);
  s:=InputBox('Menu name','Enter Menu Name:', s);
  aMenuItem:=TMenuItem.Create(MainMenu);
  aMenuItem.OnClick:=@MenuClickHandler;
  aMenuItem.RadioItem:=True;
  aMenuItem.Caption:=s;
  aTargetMenu.Add(aMenuItem);
  aMenuItem.Click;
end;

procedure TForm1.MenuClickHandler(Sender: TObject);
begin
  ShowMessage('Clicked!');
end;

end.

